Update master of plcapi.
[build.git] / vbuild-nightly.sh
index d9e8710..7ee1aef 100755 (executable)
@@ -1,5 +1,5 @@
 #!/bin/bash
-REVISION=$(echo '$Revision$' | sed -e 's,\$,,g' -e 's,^\w*:\s,,' )
+REVISION=$(echo '$Revision: 18120 $' | sed -e 's,\$,,g' -e 's,^\w*:\s,,' )
 
 COMMANDPATH=$0
 COMMAND=$(basename $0)
@@ -9,21 +9,36 @@ DEFAULT_FCDISTRO=centos5
 DEFAULT_PLDISTRO=planetlab
 DEFAULT_PERSONALITY=linux32
 DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
-DEFAULT_build_SVNPATH="http://svn.planet-lab.org/svn/build/trunk"
-DEFAULT_TESTCONFIG="default"
+DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
 DEFAULT_IFNAME=eth0
 
-# web publishing results
-DEFAULT_WEBPATH="/build/@PLDISTRO@/"
-
 # default gpg path used in signing yum repo
 DEFAULT_GPGPATH="/etc/planetlab"
 # default email to use in gpg secring
 DEFAULT_GPGUID="root@$( /bin/hostname )"
 
-# for the test part
-DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
-TESTBOXSSH=root@testbox.onelab.eu
+DEFAULT_TESTCONFIG="default"
+# for passing args to run_log
+RUN_LOG_EXTRAS=""
+
+# for publishing results, and the tests settings
+x=$(hostname)
+y=$(hostname|sed -e s,inria,,)
+# INRIA defaults
+if [ "$x" != "$y" ] ; then
+    DEFAULT_WEBPATH="/build/@PLDISTRO@/"
+    DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
+    # this is where the buildurl is pointing towards
+    DEFAULT_WEBROOT="/build/"
+    DEFAULT_TESTMASTER="testmaster.onelab.eu"
+else
+    DEFAULT_WEBPATH="/build/@FCDISTRO@/@PLDISTRO@/"
+    DEFAULT_TESTBUILDURL="http://build.planet-lab.org/"
+    # this is where the buildurl is pointing towards
+    DEFAULT_WEBROOT="/build/"
+    DEFAULT_TESTMASTER="manager.test.planet-lab.org"
+fi    
+
 ####################
 # assuming vserver runs in UTC
 DATE=$(date +'%Y.%m.%d')
@@ -39,7 +54,7 @@ function summary () {
 # read a full log and tries to extract the interesting stuff
 
 import sys,re
-m_show_line=re.compile(".* BEG (RPM|VSERVER).*|.*'boot'.*|\* .*|.*is not installed.*|.*PROPFIND.*|.*Starting.*:runtest.*")
+m_show_line=re.compile(".* (BEG|END) (RPM|VSERVER).*|.*'boot'.*|\* .*| \* .*|.*is not installed.*|.*PROPFIND.*|.* (BEG|END).*:run_log.*|.* Within vserver (BEG|END) .*|.* MAIN (BEG|END).*")
 m_installing_any=re.compile('\r  (Installing:[^\]]*]) ')
 m_installing_err=re.compile('\r  (Installing:[^\]]*])(..+)')
 m_installing_end=re.compile('Installed:.*')
@@ -94,24 +109,42 @@ EOF
     echo "******************** END SUMMARY" 
 }
 
+### we might build on a box other than the actual web server
+# utilities for handling the pushed material (rpms, logfiles, ...)
+function webpublish_misses_dir () { ssh root@${WEBHOST}  "bash -c \"test \! -d $1\"" ; }
+function webpublish () { ssh root@${WEBHOST} "$@" ; }
+function webpublish_rsync_dir () { rsync --archive --delete $VERBOSE $1 root@${WEBHOST}:$2 ; }
+function webpublish_rsync_file () { rsync $VERBOSE $1 root@${WEBHOST}:$2 ; }
+function webpublish_cp_local_to_remote () { scp $1 root@${WEBHOST}:$2 ; }
+function webpublish_cp_stdin_to_file () { ssh root@${WEBHOST} cat \> $1; }
+function webpublish_append_stdin_to_file () { ssh root@${WEBHOST} cat \>\> $1; }
 
 # Notify recipient of failure or success, manage various stamps 
 function failure() {
     set -x
     # early stage ? - let's not create /build/@PLDISTRO@
-    if [ ! -d ${WEBPATH} ] ; then
+    if test -z "$WEBLOG" ; then
+       WEBHOST=localhost
        WEBPATH=/tmp
-       WEBLOG=/tmp/vbuild-early.log.txt
+       WEBBASE=/tmp/vbuild-early-$(date +%Y-%m-%d)
+       WEBLOG=/tmp/vbuild-early-$(date +%Y-%m-%d).log.txt
     fi
-    cp $LOG ${WEBLOG}
-    summary $LOG >> ${WEBLOG}
-    (echo -n "============================== $COMMAND: failure at " ; date ; tail -c 30k $WEBLOG) > ${WEBLOG}.ko
+    webpublish mkdir -p $WEBBASE ||:
+    webpublish_cp_local_to_remote $LOG $WEBLOG ||:
+    summary $LOG | webpublish_append_stdin_to_file $WEBLOG ||:
+    (echo -n "============================== $COMMAND: failure at " ; date ; \
+       webpublish tail --lines=1000 $WEBLOG) | \
+       webpublish_cp_stdin_to_file $WEBBASE.ko ||:
     if [ -n "$MAILTO" ] ; then
        ( \
-           echo "See full build log at ${LOG_URL}" ; \
-           echo "and tail version at ${LOG_URL}.ko" ; \
-           echo "See complete set of testlogs at ${TESTLOGS_URL}" ; \
-           tail -c 30k ${WEBLOG} ) | mail -s "Failures with ${MAIL_SUBJECT}" $MAILTO
+           echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
+           echo "To: $MAILTO" ; \
+           echo "See full build log at $WEBBASE_URL/log.txt" ; \
+           echo "and tail version at $WEBBASE_URL.ko" ; \
+           echo "See complete set of testlogs at $WEBBASE_URL/testlogs" ; \
+           echo "........................................" ; \
+           webpublish tail --lines=1000 $WEBLOG ) | \
+           sendmail $MAILTO
     fi
     exit 1
 }
@@ -119,32 +152,40 @@ function failure() {
 function success () {
     set -x
     # early stage ? - let's not create /build/@PLDISTRO@
-    if [ ! -d ${WEBPATH} ] ; then
+    if test -z "$WEBLOG" ; then
+       WEBHOST=localhost
        WEBPATH=/tmp
-       WEBLOG=/tmp/vbuild-early.log.txt
+       WEBLOG=/tmp/vbuild-early-$(date +%Y-%m-%d).log.txt
     fi
-    cp $LOG ${WEBLOG}
-    summary $LOG >> ${WEBLOG}
+    webpublish mkdir -p $WEBBASE
+    webpublish_cp_local_to_remote $LOG $WEBLOG
+    summary $LOG | webpublish_append_stdin_to_file $WEBLOG
     if [ -n "$DO_TEST" ] ; then
        ( \
            echo "Successfully built and tested" ; \
-           echo "See full build log at ${LOG_URL}" ; \
-           echo "See complete set of testlogs at ${TESTLOGS_URL}" ; \
-           ) > ${WEBLOG}.pass
-       rm -f ${WEBLOG}.ok ${WEBLOG}.ko
+           echo "See full build log at $WEBBASE_URL/log.txt" ; \
+           echo "See complete set of testlogs at $WEBBASE_URL/testlogs" ; \
+           ) | webpublish_cp_stdin_to_file $WEBBASE.pass
+       webpublish rm -f $WEBBASE.pkg-ok $WEBBASE.ko
     else
        ( \
-           echo "Successfully built, no test requested" ; \
-           echo "See full build log at ${LOG_URL}" ; \
-           ) > ${WEBLOG}.ok
+           echo "Successful package-only build, no test requested" ; \
+           echo "See full build log at $WEBBASE_URL/log.txt" ; \
+           ) | webpublish_cp_stdin_to_file $WEBBASE.pkg-ok
+       webpublish rm -f $WEBBASE.ko
     fi
     if [ -n "$MAILTO" ] ; then
        ( \
+           echo "Subject: PASS ${BASE} ${MAIL_SUBJECT}" ; \
+           echo "To: $MAILTO" ; \
            echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
-           echo "See full build log at ${LOG_URL}" ; \
-            [ -n "$DO_TEST" ] && echo "See complete set of testlogs at ${TESTLOGS_URL}" ) \
-           | mail -s "Success with ${MAIL_SUBJECT}" $MAILTO
+           echo "See full build log at $WEBBASE_URL/log.txt" ; \
+            [ -n "$DO_TEST" ] && echo "See complete set of testlogs at $WEBBASE_URL/testlogs" ) \
+           | sendmail $MAILTO
     fi
+    # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
+    # doesn't fix the problem, I'll remove it -- Sapan.
+    sleep 5
     exit 0
 }
 
@@ -157,28 +198,31 @@ function build () {
     date
 
     cd /build
-  # if TAGSRELEASE specified : update PLDISTROTAGS with this tag
-    if [ -n "$TAGSRELEASE" ] ; then
-       svn up -r $TAGSRELEASE $PLDISTROTAGS
-    fi
-
     show_env
     
     echo "Running make IN $(pwd)"
     
     # stuff our own variable settings
+    if echo $BUILD_SCM_URL | grep -q git ; then
+       MAKEVARS=("build-GITPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
+    else
+       MAKEVARS=("build-SVNPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
+    fi
     MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
     MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
-    MAKEVARS=("build-SVNPATH=${build_SVNPATH}" "${MAKEVARS[@]}")
     MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
     MAKEVARS=("MAILTO=${MAILTO}" "${MAKEVARS[@]}")
+    MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
+    MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
+    MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
 
     MAKEVARS=("BASE=${BASE}" "${MAKEVARS[@]}")
 
+    # initialize latex
+    /build/latex-first-run.sh || :
+
     # stage1
     make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true 
-    # store tests_svnpath
-    make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true tests_svnpath
     # versions
     make -C /build $DRY_RUN "${MAKEVARS[@]}" versions
     # actual stuff
@@ -188,32 +232,22 @@ function build () {
 
 # this was formerly run in the myplc-devel chroot but now is run in the root context,
 # this is so that the .ssh config gets done manually, and once and for all
-function runtest () {
+function run_log () {
     set -x
     set -e
     trap failure ERR INT
 
-    echo -n "============================== Starting $COMMAND:runtest on $(date)"
-
-    # where to find TESTS_SVNPATH
-    stamp=/vservers/$BASE/build/tests_svnpath
-    if [ ! -f $stamp ] ; then
-       echo "$COMMAND: Cannot figure TESTS_SVNPATH from missing $stamp"
-       failure
-       exit 1
-    fi
-    TESTS_SVNPATH=$(cat $stamp)
-    # xxx - Thierry - need to rework the test framework in tests/system so it can work
-    # with the entire tests/ module checked out, rather than only tests/system/ 
-    # ugly workaround for now
-    TESTS_SYSTEM_SVNPATH=${TESTS_SVNPATH}/system
+    echo "============================== BEG $COMMAND:run_log on $(date)"
 
     ### the URL to the RPMS/<arch> location
+    # f12 now has everything in i686; try i386 first as older fedoras have both
     url=""
-    for a in i386 x86_64; do
+    for a in i386 i686 x86_64; do
        archdir=/vservers/$BASE/build/RPMS/$a
        if [ -d $archdir ] ; then
-           url=$(echo $archdir | sed -e "s,/vservers/$BASE/build,${TESTBUILDURL}${PLDISTRO}/${BASE},")
+           # where was that installed
+           url=$(echo $archdir | sed -e "s,/vservers/${BASE}/build,${WEBPATH}/${BASE},")
+           url=$(echo $url | sed -e "s,${WEBROOT},${TESTBUILDURL},")
            break
        fi
     done
@@ -224,44 +258,53 @@ function runtest () {
        exit 1
     fi
 
+    testmaster_ssh="root@${TESTMASTER}"
+
     # test directory name on test box
     testdir=${BASE}
+
     # clean it
-    ssh -n ${TESTBOXSSH} rm -rf ${testdir}
-    # check it out 
-    ssh -n ${TESTBOXSSH} svn co ${TESTS_SYSTEM_SVNPATH} ${testdir}
-    # check out the entire tests/ module (with system/ duplicated) as a subdir - see xxx above
-    ssh -n ${TESTBOXSSH} svn co ${TESTS_SVNPATH} ${testdir}/tests
+    ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
+
+    # check it out in the build
+    vserver $BASE exec make -C /build tests-module
+    
+    # push it onto the testmaster - just the 'system' subdir is enough
+    rsync --verbose --archive /vservers/$BASE/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
+    # toss the build in the bargain, so the tests don't need to mess with extracting it
+    rsync --verbose --archive /vservers/$BASE/build/MODULES/build ${testmaster_ssh}:${BASE}/
+
     # invoke test on testbox - pass url and build url - so the tests can use vtest-init-vserver.sh
-    configs=""
-    for config in ${TESTCONFIG} ; do
-       configs="$configs --config $config"
-    done
-    test_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
+    run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
 
     # need to proceed despite of set -e
     success=true
-    ssh 2>&1 -n ${TESTBOXSSH} ${testdir}/runtest --build ${build_SVNPATH} --url ${url} $configs $test_env --all || success=
+    # passing the build_scm_url should not be needed anymore
+    ssh 2>&1 -n ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all || success=
 
-    # gather logs in the vserver
+    # gather logs in the build vserver
     mkdir -p /vservers/$BASE/build/testlogs
-    ssh 2>&1 -n ${TESTBOXSSH} tar -C ${testdir}/logs -cf - . | tar -C /vservers/$BASE/build/testlogs -xf - || true
+    rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ /vservers/$BASE/build/testlogs
     # push them to the build web
     chmod -R a+r /vservers/$BASE/build/testlogs/
-    rsync --archive --delete /vservers/$BASE/build/testlogs/ $WEBPATH/$BASE/testlogs/
+    webpublish_rsync_dir /vservers/$BASE/build/testlogs/ $WEBPATH/$BASE/testlogs/
+
+    echo  "============================== END $COMMAND:run_log on $(date)"
 
     if [ -z "$success" ] ; then
+       echo "Tests have failed - bailing out"
        failure
     fi
     
-    echo -n "============================== End $COMMAND:runtest on $(date)"
 }
 
 function in_root_context () {
     rpm -q util-vserver > /dev/null 
 }
 
-# this part won't work with a remote(rsync) WEBPATH
+# this part won't work if WEBHOST does not match the local host
+# would need to be made webpublish_* compliant
+# but do we really need this feature anyway ?
 function sign_node_packages () {
 
     echo "Signing node packages"
@@ -316,14 +359,14 @@ function show_env () {
     echo PLDISTRO=$PLDISTRO
     echo PERSONALITY=$PERSONALITY
     echo BASE=$BASE
-    echo build_SVNPATH=$build_SVNPATH
+    echo BUILD_SCM_URL=$BUILD_SCM_URL
     echo MAKEVARS="${MAKEVARS[@]}"
     echo DRY_RUN="$DRY_RUN"
     echo PLDISTROTAGS="$PLDISTROTAGS"
-    echo TAGSRELEASE="$TAGSRELEASE"
     # this does not help, it's not yet set when we run show_env
     #echo WEBPATH="$WEBPATH"
     echo TESTBUILDURL="$TESTBUILDURL"
+    echo WEBHOST="$WEBHOST"
     if in_root_context ; then
        echo PLDISTROTAGS="$PLDISTROTAGS"
     else
@@ -338,6 +381,24 @@ function show_env () {
     set -x
 }
 
+function setupssh () {
+    base=$1; shift
+    sshkey=$1; shift
+    
+    if [ -f ${sshkey} ] ; then
+       SSHDIR=/vservers/${base}/root/.ssh
+       mkdir -p ${SSHDIR}
+       cp $sshkey ${SSHDIR}/thekey
+       (echo "host *"; \
+           echo "  IdentityFile ~/.ssh/thekey"; \
+           echo "  StrictHostKeyChecking no" ) > ${SSHDIR}/config
+       chmod 700 ${SSHDIR}
+       chmod 400 ${SSHDIR}/*
+    else 
+       echo "WARNING : could not find provided ssh key $sshkey - ignored"
+    fi
+}
+
 function usage () {
     echo "Usage: $COMMAND [option] [var=value...] make-targets"
     echo "This is $REVISION"
@@ -345,26 +406,33 @@ function usage () {
     echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
+    echo " -m mailto - no default"
+    echo " -s build_scm_url - git or svn URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
+    echo "    define GIT tag or branch name appending @tagname to url"
+    echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
     echo " -b base - defaults to $DEFAULT_BASE"
     echo "    @NAME@ replaced as appropriate"
     echo " -o base: (overwrite) do not re-create vserver, re-use base instead"
-    echo "    the -f/-d/-t/-s/-p/-m options are uneffective in this case"
-    echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
-    echo " -r tagsrelease - a release number that refers to PLDISTROTAGS - defaults to HEAD"
-    echo " -s svnpath - where to fetch the build module - defaults to $DEFAULT_build_SVNPATH"
+    echo "    the -f/-d/-p/-m/-s/-t options are uneffective in this case"
     echo " -c testconfig - defaults to $DEFAULT_TESTCONFIG"
+    echo " -y {pl,pg} - passed to run_log"
+    echo " -x <run_log_args> - a hook to pass arguments to run_log"
     echo " -w webpath - defaults to $DEFAULT_WEBPATH"
-    echo " -W testbuildurl - defaults to $DEFAULT_TESTBUILDURL"
-    echo " -y sign yum repo in webpath"
-    echo " -g path to gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH" 
-    echo " -u gpg email used in secring. Defaults to $DEFAULT_GPGUID"
-    echo " -m mailto - no default"
-    echo " -B : run build only"
-    echo " -T : run test only"
-    echo " -n dry-run : -n passed to make - vserver gets created though - no mail sent"
-    echo " -v : be verbose"
-    echo " -7 : uses weekday-@FCDISTRO@ as base"
+    echo " -W testbuildurl - defaults to $DEFAULT_TESTBUILDURL; this is also used to get the hostname where to publish builds"
+    echo " -r webroot - defaults to $DEFAULT_WEBROOT - the fs point where testbuildurl actually sits"
+    echo " -M testmaster - defaults to $DEFAULT_TESTMASTER"
+    echo " -Y - sign yum repo in webpath"
+    echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH" 
+    echo " -u gpg_uid - email used in secring. Defaults to $DEFAULT_GPGUID"
+    echo " -K svnsshkey - specify key to use when svn+ssh:// URLs are used for SVNPATH"
+    echo " -S - do not publish source rpms"
+    echo " -B - run build only"
+    echo " -T - run test only"
+    echo " -n - dry-run: -n passed to make - vserver gets created though - no mail sent"
+    echo " -v - be verbose"
+    echo " -7 - uses weekday-@FCDISTRO@ as base"
     echo " -i ifname - defaults to $DEFAULT_IFNAME - used to determine local IP"
+    echo " --build-branch branch - build using the branch from build module"
     exit 1
 }
 
@@ -378,38 +446,52 @@ function main () {
     DRY_RUN=
     DO_BUILD=true
     DO_TEST=true
+    PUBLISH_SRPMS=true
+    SSH_KEY=""
     SIGNYUMREPO=""
-    while getopts "f:d:p:b:o:t:r:s:x:c:w:W:g:u:m:BTnyv7i:" opt ; do
-       case $opt in
-           f) FCDISTRO=$OPTARG ;;
-           d) PLDISTRO=$OPTARG ;;
-           p) PERSONALITY=$OPTARG ;;
-           b) BASE=$OPTARG ;;
-           o) OVERBASE=$OPTARG ;;
-           t) PLDISTROTAGS=$OPTARG ;;
-           r) TAGSRELEASE=$OPTARG ;;
-           s) build_SVNPATH=$OPTARG ;;
-           c) TESTCONFIG="$TESTCONFIG $OPTARG" ;;
-           w) WEBPATH=$OPTARG ;;
-           W) TESTBUILDURL=$OPTARG ;;
-            y) SIGNYUMREPO=true ;;
-            g) GPGPATH=$OPTARG ;;
-            u) GPGUID=$OPTARG ;;
-           m) MAILTO=$OPTARG ;;
-           B) DO_TEST= ;;
-           T) DO_BUILD= ;;
-           n) DRY_RUN="-n" ;;
-           v) set -x ;;
-           7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ;;
-           i) IFNAME=$OPTARG ;;
-           h|*) usage ;;
+
+    OPTS_ORIG=$@
+    OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:x:w:W:r:M:Yg:u:K:SBTnv7i:h" -l "build-branch:" -- $@)
+    if [ $? != 0 ]
+    then
+        usage
+    fi
+    eval set -- "$OPTS"
+    while true; do
+       case $1 in
+           -f) FCDISTRO=$2; shift 2 ;;
+           -d) PLDISTRO=$2; shift 2 ;;
+           -p) PERSONALITY=$2; shift 2 ;;
+           -m) MAILTO=$2; shift 2 ;;
+           -s) BUILD_SCM_URL=$2; shift 2 ;;
+           -t) PLDISTROTAGS=$2; shift 2 ;;
+           -b) BASE=$2; shift 2 ;;
+           -o) OVERBASE=$2; shift 2 ;;
+           -c) TESTCONFIG="$TESTCONFIG $2"; shift 2 ;;
+           -y) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS -y $2"; shift 2 ;;
+           -x) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS $2"; shift 2;;
+           -w) WEBPATH=$2; shift 2 ;;
+           -W) TESTBUILDURL=$2; shift 2 ;;
+           -r) WEBROOT=$2; shift 2 ;;
+           -M) TESTMASTER=$2; shift 2 ;;
+            -Y) SIGNYUMREPO=true; shift ;;
+            -g) GPGPATH=$2; shift 2 ;;
+            -u) GPGUID=$2; shift 2 ;;
+           -K) SSH_KEY=$2; shift 2 ;;
+           -S) PUBLISH_SRPMS="" ; shift ;;
+           -B) DO_TEST= ; shift ;;
+           -T) DO_BUILD= ; shift;;
+           -n) DRY_RUN="-n" ; shift ;;
+           -v) set -x ; VERBOSE="-v" ; shift ;;
+           -7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ; shift ;;
+           -i) IFNAME=$2; shift 2 ;;
+           -h) usage ; shift ;;
+            --) shift; break ;;
        esac
     done
-       
+
     # preserve options for passing them again later, together with expanded base
-    declare -a options
-    toshift=$(($OPTIND - 1))
-    arg=1; while [ $arg -le $toshift ] ; do options=(${options[@]} "$1") ; shift; arg=$(($arg+1)) ; done
+    options=$OPTS_ORIG
 
     # allow var=value stuff; 
     for target in "$@" ; do
@@ -430,13 +512,21 @@ function main () {
     [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
     [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
     [ -z "$TESTBUILDURL" ] && TESTBUILDURL="$DEFAULT_TESTBUILDURL"
+    [ -z "$WEBROOT" ] && WEBROOT="$DEFAULT_WEBROOT"
     [ -z "$GPGPATH" ] && GPGPATH="$DEFAULT_GPGPATH"
     [ -z "$GPGUID" ] && GPGUID="$DEFAULT_GPGUID"
     [ -z "$IFNAME" ] && IFNAME="$DEFAULT_IFNAME"
-    [ -z "$build_SVNPATH" ] && build_SVNPATH="$DEFAULT_build_SVNPATH"
+    [ -z "$BUILD_SCM_URL" ] && BUILD_SCM_URL="$DEFAULT_BUILD_SCM_URL"
     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
+    [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
 
     [ -n "$DRY_RUN" ] && MAILTO=""
+
+    # elaborate the extra args to be passed to run_log
+    for config in ${TESTCONFIG} ; do
+       RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --config $config"
+    done
+    
        
     if [ -n "$OVERBASE" ] ; then
        sedargs="-e s,@DATE@,${DATE},g"
@@ -448,18 +538,24 @@ function main () {
 
     ### elaborate mail subject
     if [ -n "$DO_BUILD" -a -n "$DO_TEST" ] ; then
-       MAIL_SUBJECT="complete"
+       MAIL_SUBJECT="full"
     elif [ -n "$DO_BUILD" ] ; then
-       MAIL_SUBJECT="package-only"
+       MAIL_SUBJECT="pkg-only"
     elif [ -n "$DO_TEST" ] ; then
        MAIL_SUBJECT="test-only"
     fi
     if [ -n "$OVERBASE" ] ; then
-       MAIL_SUBJECT="$MAIL_SUBJECT incremental run on"
+       MAIL_SUBJECT="${MAIL_SUBJECT} rerun"
     else
-       MAIL_SUBJECT="$MAIL_SUBJECT fresh build"
+       MAIL_SUBJECT="${MAIL_SUBJECT} fresh"
     fi
-    MAIL_SUBJECT="$MAIL_SUBJECT ${BASE}"
+    short_hostname=$(hostname | cut -d. -f1)
+    MAIL_SUBJECT="on ${short_hostname} - ${MAIL_SUBJECT}"
+
+    ### compute WEBHOST from TESTBUILDURL 
+    # this is to avoid having to change the builds configs everywhere
+    # simplistic way to extract hostname from a URL
+    WEBHOST=$(echo "$TESTBUILDURL" | cut -d/ -f 3)
 
     if ! in_root_context ; then
         # in the vserver
@@ -488,16 +584,30 @@ function main () {
            echo "XXXXXXXXXX $COMMAND: using existing vserver $BASE" $(date)
            # start in case e.g. we just rebooted
            vserver ${BASE} start || :
-           # update build
-           vserver ${BASE} exec svn update /build
-           # get environment from the first run 
+           # retrieve environment from the previous run
            FCDISTRO=$(vserver ${BASE} exec /build/getdistroname.sh)
-
-           PLDISTRO=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +PLDISTRO)
-           PLDISTROTAGS=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +PLDISTROTAGS)
-           build_SVNPATH=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +build-SVNPATH)
-           PERSONALITY=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +PERSONALITY)
-           MAILTO=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +MAILTO)
+           BUILD_SCM_URL=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +build-SVNPATH +build-GITPATH)
+           # for efficiency, crop everything in one make run
+           tmp=/tmp/${BASE}-env.sh
+           vserver ${BASE} exec make --no-print-directory -C /build stage1=skip \
+               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT > $tmp
+           . $tmp
+           rm -f $tmp
+           # update build
+           [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
+           if echo $BUILD_SCM_URL | grep -q git ; then
+               vserver $BASE exec bash -c "cd /build; git pull; make tests-clean"
+           else
+               vserver $BASE exec svn update /build
+           fi
+           # make sure we refresh the tests place in case it has changed
+           rm -f /build/MODULES/tests
+           options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
+           [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
+           [ -n "$MAILTO" ] && options=(${options[@]} -m $MAILTO)
+           [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
+           [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
+           [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
            show_env
        else
            # create vserver: check it does not exist yet
@@ -523,16 +633,29 @@ function main () {
 
            ### extract the whole build - much simpler
            tmpdir=/tmp/$COMMAND-$$
-           svn export $build_SVNPATH $tmpdir
+           if echo $BUILD_SCM_URL | grep -q git ; then
+               GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
+               GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
+               GIT_TAG=${GIT_TAG:-master}
+               mkdir -p $tmpdir; git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -
+           else
+               svn export $BUILD_SCM_URL $tmpdir
+           fi
             # Create vserver
            cd $tmpdir
-           ./vbuild-init-vserver.sh -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} -i ${IFNAME} ${BASE} 
+           ./vbuild-init-vserver.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} -i ${IFNAME} ${BASE} 
            # cleanup
            cd -
            rm -rf $tmpdir
            # Extract build again - in the vserver
-           vserver ${BASE} exec svn checkout ${build_SVNPATH} /build
+           [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
+           if echo $BUILD_SCM_URL | grep -q git ; then
+               vserver $BASE exec bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
+           else
+               vserver $BASE exec svn checkout ${BUILD_SCM_URL} /build
+           fi
        fi
+       # install ssh key in vserver
        echo "XXXXXXXXXX $COMMAND: preparation of vserver $BASE done" $(date)
 
        # The log inside the vserver contains everything
@@ -549,16 +672,17 @@ function main () {
 
        sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
        WEBPATH=$(echo ${WEBPATH} | sed $sedargs)
-       mkdir -p ${WEBPATH}
+       webpublish mkdir -p ${WEBPATH}
 
         # where to store the log for web access
-       WEBLOG=${WEBPATH}/${BASE}.log.txt
+       WEBBASE=${WEBPATH}/${BASE}
+       WEBLOG=${WEBPATH}/${BASE}/log.txt
         # compute the log URL - inserted in the mail messages for convenience
-       LOG_URL=$(echo ${WEBLOG} | sed -e "s,//,/,g" -e "s,/build/,${TESTBUILDURL},")
-       TESTLOGS_URL=$(echo ${WEBPATH}/${BASE}/testlogs | sed -e "s,//,/,g" -e "s,/build/,${TESTBUILDURL},")
+       WEBBASE_URL=$(echo $WEBBASE | sed -e "s,//,/,g" -e "s,${WEBROOT},${TESTBUILDURL},")
     
        if [ -n "$DO_BUILD" ] ; then 
 
+           # invoke this command into the build directory of the vserver
            cp $COMMANDPATH /vservers/${BASE}/build/
 
            # invoke this command in the vserver for building (-T)
@@ -566,24 +690,37 @@ function main () {
            vserver ${BASE} exec /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
        fi
 
-       # publish to the web so runtest can find them
-       rm -rf $WEBPATH/$BASE ; mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
-       rsync --archive --delete --verbose /vservers/$BASE/build/RPMS/ $WEBPATH/$BASE/RPMS/
-       rsync --archive --delete --verbose /vservers/$BASE/build/SRPMS/ $WEBPATH/$BASE/SRPMS/
-       # publish myplc-release
-       rsync --verbose /vservers/$BASE/build/myplc-release $WEBPATH/$BASE
+       # publish to the web so run_log can find them
+       set +e
+       webpublish rm -rf $WEBPATH/$BASE 
+       webpublish mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
+       webpublish_rsync_dir /vservers/$BASE/build/RPMS/ $WEBPATH/$BASE/RPMS/
+       [[ -n "$PUBLISH_SRPMS" ]] && webpublish_rsync_dir /vservers/$BASE/build/SRPMS/ $WEBPATH/$BASE/SRPMS/
+       # publish myplc-release if this exists
+       release=/vservers/$BASE/build/myplc-release
+       [ -f $release ] && webpublish_rsync_file $release $WEBPATH/$BASE
+       set -e
 
         # create yum repo and sign packages.
        if [ -n "$SIGNYUMREPO" ] ; then
-           sign_node_packages
+           # this script does not yet support signing on a remote (webhost) repo
+           sign_here=$(hostname) ; sign_web=$(webpublish hostname)
+           if [ "$hostname" = "$sign_here" ] ; then
+               sign_node_packages
+           else
+               echo "$COMMAND does not support signing on a remote yum repo"
+               echo "you might want to turn off the -y option, or run this on the web server box itself"
+               exit 1
+           fi
        fi
 
        if [ -n "$DO_TEST" ] ; then 
-           runtest
+           run_log
        fi
 
        success 
-       
+
+        echo "==================== MAIN END $(date)"   
     fi
 
 }